﻿using System;
using System.Collections.Generic;
using System.Drawing;
using System.Threading;
using System.Threading.Tasks;
using System.Drawing.Imaging;
using System.ComponentModel;
using System.IO;
using System.Text;
using System.Windows.Forms;
using Tao.OpenGl;
using Tao.OpenGl;
namespace Rhenin
{
    public partial class Form1 : Form
    {
        public static Form1 instance;

        public static String version = "Alpha Version";

        String appPath = System.Windows.Forms.Application.StartupPath + "/";
        String editPath = null;
        bool onePick = false;
        bool pick = false;
        int currentKey = 0;
        int drawMode = 0;
        int baseModelMode = 0;
        bool hasTexture = false;
        Point hasTexturePoint = new Point();
        bool sousa = false;
        public List<GlBox> boxs = new List<GlBox>(20);
        Image modelTex = null;
        GlBox grassBlock = new GlBox(16, 16, 16, -8, 24, -8, 0, 0, 0);
        GlBox downBlock = new GlBox(64, 64, 64, -32, -32, -32, 0, 0, 0);
        List<GlBox> baseModel = null;
        int keyCount = 0;
        public double[] lookAt = new double[] { 30.0, -7.0, -80.0, 0.0, 0.0, 0.0 };
        public static bool showHelp = false;

        #region クォータニオン
        double sx, sy;
        int startX;
        int startY;
        double[] cq = new double[] { 1.0, 0.0, 0.0, 0.0 };
        double[] tq = new double[] { 0.0, 0.0, 0.0, 0.0 };
        public static double[] rt = new double[16];
        public static double scale = 1.0d;
        #endregion

        GlBox boxClipBoard = null;

        public First firstFrom = new First();

        public Form1()
        {
            firstFrom.Show();
            for (int i = 0; i < 1; i++)
            {
                Application.DoEvents();
                System.Threading.Thread.Sleep(1);
            }
            InitializeComponent();
            if (!Directory.Exists(appPath + "Data"))
            {
                MessageBox.Show("Dataフォルダが存在しません");
                Application.Exit();
            }
            CheckForIllegalCrossThreadCalls = false;
            view.InitializeContexts();
            glInit();
            addLog("OpenGL 初期化完了");
            view.Refresh();
            instance = this;
        }

        private void addBox_Click(object sender, EventArgs e)
        {
            if (textBox1.Text != null && textBox1.Text != "" && programString(textBox1.Text) && !boxList.Items.Contains(textBox1.Text))
            {
                boxList.Items.Add(textBox1.Text);
                addInstance(textBox1.Text);
                addLog("箱の追加 " + textBox1.Text);
                textBox1.Text = "";
            }
            else if (textBox1.Text == "")
            {
                for (int i = 1; i <= 1000; i++)
                {
                    String name = "box" + i;
                    if (!boxList.Items.Contains(name))
                    {
                        boxList.Items.Add(name);
                        addLog("箱の追加 " + name);
                        addInstance(name);
                        break;
                    }
                }
            }
            else
            {
                addLog("箱の追加に失敗しました " + textBox1.Text);
            }
            
        }

        private void addInstance(String name)
        {
            GlBox box = new GlBox(8, 8, 8);
            box.name = name;
            boxs.Add(box);
            boxList.SelectedIndex = boxList.Items.Count - 1;
            view.Invalidate();
            textureImage.Invalidate();
            view.Focus();
        }

        private bool programString(string par1)
        {
            if (isHankaku(par1))
            {
                bool flag = true;
                char[] chars = { '!', '=', '(', ')', '&', '%', '\'', '\"', '\\', '#', '$', '+', '*', '-', '/', ',', '.', '<', '>', '?', '[', ']', '{', '}', '@', ';', ':', '^', '|', ' '};
                for (int i = 0; i < par1.Length; i++)
                {
                    for (int j = 0; j < chars.Length; j++)
                    {
                        if (par1[i] == chars[j])
                        {
                            flag = false;
                            return flag;
                        }
                    }
                }
                return flag;
            }
            return false;
        }

        private bool isHankaku(string par1)
        {
            Encoding sjisEnc = Encoding.GetEncoding("Shift_JIS");
            int num = sjisEnc.GetByteCount(par1);
            return num == par1.Length;
        }

        public void addLog(String par1)
        {
            logs.Text += par1 + "\r\n";
            logs.SelectionStart = logs.Text.Length;
            logs.ScrollToCaret();
        }

        public static void GlInitPush()
        {
            Gl.glScaled(Form1.scale, Form1.scale, Form1.scale);
            Gl.glMultMatrixd(Form1.rt);
        }

        private void glInit()
        {
            Gl.glClearColor(0.973F, 0.973F, 1.000F, 1.0F);
            Gl.glViewport(0, 0, view.Width, view.Height);
            Gl.glMatrixMode(Gl.GL_PROJECTION);
            Gl.glLoadIdentity();
            Glu.gluPerspective(30, (double)view.Width / (double)view.Height, 1.0, 500);

            Gl.glMatrixMode(Gl.GL_MODELVIEW);
            Gl.glLoadIdentity();

            Glu.gluLookAt(30.0, -7.0, -80.0, 0.0, 0.0, 0.0, 0.0, -1.0, 0.0);

            Gl.glEnable(Gl.GL_CULL_FACE);
            Gl.glEnable(Gl.GL_DEPTH_TEST);
            Gl.glCullFace(Gl.GL_FRONT);
            Gl.glHint(Gl.GL_LINE_SMOOTH_HINT, Gl.GL_DONT_CARE);
            Gl.glBlendFunc(Gl.GL_SRC_ALPHA, Gl.GL_ONE_MINUS_SRC_ALPHA);

            view.Invalidate();

            double dx = 3;
            double dy = 3;
            double a = Math.Sqrt(dx * dx + dy * dy);
            if (a != 0.0)
            {
                double SCALE = Math.PI * 0.95;
                double ar = a * SCALE * 0.5;
                double _as = Math.Sin(ar) / a;
                double[] dq = new double[] { Math.Cos(ar), dy * _as, dx * _as, 0.0 };
                GLUtil.qmul(out tq, dq, cq);
                GLUtil.qrot(out rt, tq);
                view.Focus();
                view.Invalidate();
            }
        }

        private void glPaintEvt()
        {
            Gl.glViewport(0, 0, view.Width, view.Height);
            Gl.glMatrixMode(Gl.GL_PROJECTION);
            Gl.glLoadIdentity();
            Glu.gluPerspective(30, (double)view.Width / (double)view.Height, 1.0, 500);

            Gl.glMatrixMode(Gl.GL_MODELVIEW);

            sx = 1.0 / (double)view.Width;
            sy = 1.0 / (double)view.Height;
        }

        private void view_Paint(object sender, PaintEventArgs e)
        {
            if (!pick)
            {
                glPaintEvt();
                Gl.glClear(Gl.GL_COLOR_BUFFER_BIT | Gl.GL_DEPTH_BUFFER_BIT);

                baseModelLoad();

                Gl.glPushMatrix();
                Gl.glColor3f(0.863F, 0.863F, 0.863F);
                bindTexture(Rhenin.Properties.Resources.texture);

                if (modelTex != null)
                {
                    bindTexture(modelTex);
                }
                else
                {
                    bindTexture(Rhenin.Properties.Resources.texture);
                }

                for (int i = 0; i < boxs.Count; i++)
                {
                    boxs[i].drawMode = drawMode;
                    boxs[i].render();
                    if (boxList.SelectedIndex == i)
                    {
                        Gl.glColor3f(1F, 1F, 0F);
                        int mode = boxs[i].drawMode;
                        Gl.glEnable(Gl.GL_LINE_SMOOTH);
                        Gl.glLineWidth(3);
                        boxs[i].drawMode = 1;
                        boxs[i].render();
                        boxs[i].drawMode = mode;
                        Gl.glPushMatrix();
                        Gl.glDisable(Gl.GL_DEPTH_TEST);
                        GlInitPush();
                        Gl.glTranslated(boxs[i].x, boxs[i].y, boxs[i].z);
                        Glu.gluSphere(Tao.OpenGl.Glu.gluNewQuadric(), 1.2, 10, 10);
                        Gl.glDisable(Gl.GL_LINE_SMOOTH);
                        Gl.glEnable(Gl.GL_DEPTH_TEST);
                        Gl.glLineWidth(1);
                        Gl.glPopMatrix();
                        Gl.glColor3f(0.78F, 0.78F, 0.78F);
                        if (modelTex != null)
                        {
                            bindTexture(modelTex);
                        }
                        else
                        {
                            bindTexture(Rhenin.Properties.Resources.texture);
                        }
                    }
                }
                Gl.glPopMatrix();

                if (checkBox1.Checked)
                {
                    bindTexture(Rhenin.Properties.Resources.grassBlock);
                    grassBlock.render();
                }

                if (checkBox2.Checked)
                {
                    Gl.glPushMatrix();
                    GlInitPush();

                    Gl.glEnable(Gl.GL_LINE_SMOOTH);
                    Gl.glEnable(Gl.GL_BLEND);
                    Gl.glBegin(Gl.GL_LINES);
                    Gl.glColor3f(0.5F, 0.5F, 0.5F);
                    for (float i = -64; i < 65; i += (int)numericUpDown1.Value)
                    {
                        Gl.glVertex3f(-64, (int)numericUpDown2.Value, i);
                        Gl.glVertex3f(64, (int)numericUpDown2.Value, i);
                        Gl.glVertex3f(i, (int)numericUpDown2.Value, -64);
                        Gl.glVertex3f(i, (int)numericUpDown2.Value, 64);
                    }
                    Gl.glDisable(Gl.GL_LINE_SMOOTH);
                    Gl.glDisable(Gl.GL_BLEND);
                    Gl.glEnd();
                    Gl.glPopMatrix();
                }
                if (checkBox3.Checked)
                {
                    drawLine(new Vector3(0, 0, 0), new Vector3(256, 0, 0), new Vector3(1, 0, 0));
                    drawLine(new Vector3(0, 0, 0), new Vector3(0, 256, 0), new Vector3(0, 1, 0));
                    drawLine(new Vector3(0, 0, 0), new Vector3(0, 0, 256), new Vector3(0, 0, 1));
                }
                //drawDownBox();
            }
        }

        private void baseModelLoad()
        {
            if(baseModel != null)
            {
                Gl.glPushMatrix();
                Gl.glColor4f(0.2F, 0.2F, 0.2F, 0.2F);
                bindTexture(Rhenin.Properties.Resources.texture);
                for(int i = 0; i < baseModel.Count; i++)
                {
                    baseModel[i].drawMode = baseModelMode;
                    baseModel[i].render();
                }
                Gl.glPopMatrix();
            }
        }

        private void drawDownBox()
        {
            Gl.glPushMatrix();
            Gl.glOrtho(0, 0, view.Width, view.Height, 0, 0);
            bindTexture(Rhenin.Properties.Resources.block);
            Gl.glDepthFunc(Gl.GL_FALSE);
            Gl.glScalef(0.1F, 0.1F, 0.1F);
            Gl.glMultMatrixd(Form1.rt);
            Gl.glTranslatef(100F, 100F, 0F);
            downBlock.render(false);
            Gl.glDepthFunc(Gl.GL_TRUE);
            Gl.glPopMatrix();
        }

        private void drawLine(Vector3 par1, Vector3 par2, Vector3 color)
        {
            Gl.glPushMatrix();
            GlInitPush();
            Gl.glEnable(Gl.GL_LINE_SMOOTH);
            Gl.glEnable(Gl.GL_BLEND);
            Gl.glBegin(Gl.GL_LINES);
            Gl.glColor3f((float)color.angleX, (float)color.angleY, (float)color.angleZ);
            Gl.glVertex3f((float)par1.angleX, (float)par1.angleY, (float)par1.angleZ);
            Gl.glVertex3f((float)par2.angleX, (float)par2.angleY, (float)par2.angleZ);
            Gl.glDisable(Gl.GL_LINE_SMOOTH);
            Gl.glDisable(Gl.GL_BLEND);
            Gl.glEnd();
            Gl.glPopMatrix();
        }

        private void view_MouseMove(object sender, MouseEventArgs e)
        {
            if (e.Button == System.Windows.Forms.MouseButtons.Left)
            {
                double dx = ((startX - e.X) + (new Random().NextDouble() + 2)) * sx;
                double dy = ((e.Y - startY) + (new Random().NextDouble() + 2)) * sy;
                double a = Math.Sqrt(dx * dx + dy * dy);
                if (a != 0.0)
                {
                    double SCALE = Math.PI * 0.95;
                    double ar = a * SCALE * 0.5;
                    double _as = Math.Sin(ar) / a;
                    double[] dq = new double[] { Math.Cos(ar), dy * _as, dx * _as, 0.0 };
                    GLUtil.qmul(out tq, dq, cq);
                    GLUtil.qrot(out rt, tq);
                    view.Invalidate();
                }
            }
        }

        private void view_MouseDown(object sender, MouseEventArgs e)
        {
            if (e.Button == System.Windows.Forms.MouseButtons.Left)
            {
                startX = e.X;
                startY = e.Y;
                view.Invalidate();
                CqCheck();
                Picking(e.X, e.Y);
            }
            if (e.Button == System.Windows.Forms.MouseButtons.Right && !onePick)
            {
                Picking(e.X, e.Y);
                onePick = true;
            }
        }

        private void Picking(int x, int y)
        {
            bool ok = false;
            Gl.glPushMatrix();
            
            int[] viewport = new int[4];
            Gl.glGetIntegerv(Gl.GL_VIEWPORT, viewport);

            int selectionBufferLength = 100;
            uint[] selectionBuff = new uint[selectionBufferLength];
            Gl.glSelectBuffer(selectionBuff.Length, selectionBuff);

            Gl.glRenderMode(Gl.GL_SELECT);
            //glInit();
            Gl.glMatrixMode(Gl.GL_PROJECTION);
            
            Gl.glLoadIdentity();
            Glu.gluPickMatrix(x, viewport[3] - y, 1, 1, viewport);
            Glu.gluPerspective(30, (double)view.Width / (double)view.Height, 1.0, 500);
            //Glu.gluPerspective(30, viewport[2] / viewport[3], 1.0, 500);
            Gl.glMatrixMode(Gl.GL_MODELVIEW);
            
            Gl.glInitNames();
            Gl.glPushName(0);
            Gl.glClear(Gl.GL_COLOR_BUFFER_BIT | Gl.GL_DEPTH_BUFFER_BIT);
            for (int i = 0; i < boxs.Count; i++)
            {
                boxs[i].render();
                Gl.glLoadName(i + 1);
            }
            Gl.glMatrixMode(Gl.GL_PROJECTION);

            int hits;
            hits = Gl.glRenderMode(Gl.GL_RENDER);
            
            if (hits > 0)
            {
                ok = true;
                if (hits == 1)
                {
                    uint nameNum = selectionBuff[3];
                    boxList.SelectedIndex = (int)nameNum;
                    ok = true;
                }
                else
                {
                    uint nameNum;
                    float f1, f2;
                    f1 = (float)selectionBuff[1] / 0xFFFFFFFF;
                    nameNum = selectionBuff[3];

                    for (int i = 1; i < hits; i++)
                    {
                        f2 = (float)selectionBuff[i * 4 + 1] / 0xFFFFFFFF;
                        if (f2 < f1)
                        {
                            f1 = (float)selectionBuff[i * 4 + 1] / 0xFFFFFFFF;
                            nameNum = selectionBuff[i * 4 + 3];
                        }
                    }
                    boxList.SelectedIndex = (int)nameNum;
                }
                }
            //Gl.glLoadIdentity();

            for (int i = 0; i < boxs.Count; i++)
            {
                boxs[i].render();
            }
            Gl.glPopMatrix();
            if (ok)
            {
                lookMove(boxs[boxList.SelectedIndex].x, boxs[boxList.SelectedIndex].y, boxs[boxList.SelectedIndex].z);
            }
        }

        private void view_MouseUp(object sender, MouseEventArgs e)
        {
            if (e.Button == System.Windows.Forms.MouseButtons.Left)
            {
                cq[0] = tq[0];
                cq[1] = tq[1];
                cq[2] = tq[2];
                cq[3] = tq[3];
            }
            if (e.Button == System.Windows.Forms.MouseButtons.Right)
            {
                onePick = false;
            }
        }

        private bool CqCheck()
        {
            bool flag = true;
            for (int i = 0; i < cq.Length; i++)
            {
                if (cq[i] != 0.0)
                {
                    flag = false;
                }
            }
            if (flag)
            {
                cq = new double[] { 1.0, 0.0, 0.0, 0.0 };
            }
            return flag;
        }

        public static void bindTexture(Image img)
        {
            new Texture(img);
        }

        private void box_ber_Scroll(object sender, EventArgs e)
        {
            box_angleX.Value = box_barX.Value / 100L;
            box_angleY.Value = box_barY.Value / 100L;
            box_angleZ.Value = box_barZ.Value / 100L;
            view.Invalidate();
        }

        private void box_angle_ValueChanged(object sender, EventArgs e)
        {
            if (getCurrentBox() != null && !sousa)
            {
                boxs[boxList.SelectedIndex].angleX = (double)box_angleX.Value;
                boxs[boxList.SelectedIndex].angleY = (double)box_angleY.Value;
                boxs[boxList.SelectedIndex].angleZ = (double)box_angleZ.Value;
                view.Invalidate();
            }
            box_barX.Value = (int)box_angleX.Value * 100;
            box_barY.Value = (int)box_angleY.Value * 100;
            box_barZ.Value = (int)box_angleZ.Value * 100;
        }

        private void boxList_SelectedIndexChanged(object sender, EventArgs e)
        {
            if (boxList.SelectedIndex >= 0)
            {
                GlBox box = boxs[boxList.SelectedIndex];
                addLog("箱チェンジ " + box);
                if (box == null)
                {
                    return;
                }
                sousa = true;
                box_x.Value = (decimal)box.x;
                box_y.Value = (decimal)box.y;
                box_z.Value = (decimal)box.z;
                box_ox.Value = (decimal)box.offsetX;
                box_oy.Value = (decimal)box.offsetY;
                box_oz.Value = (decimal)box.offsetZ;
                box_width.Value = (decimal)box.width;
                box_height.Value = (decimal)box.height;
                box_depth.Value = (decimal)box.depth;
                box_angleX.Value = (decimal)box.angleX;
                box_angleY.Value = (decimal)box.angleY;
                box_angleZ.Value = (decimal)box.angleZ;
                box_textureX.Value = (decimal)box.texturePoint.X;
                box_textureY.Value = (decimal)box.texturePoint.Y;
                box_name.Text = boxList.Items[boxList.SelectedIndex].ToString();
                box_scale.Value = (decimal)box.scale;
                sousa = false;
                lookMove(box.x, box.y, box.z);
                view.Invalidate();
            }
        }

        private void lookMove(double x, double y, double z)
        {
            Gl.glMatrixMode(Gl.GL_MODELVIEW);
            Gl.glLoadIdentity();
            double zoukaX = (lookAt[3] - x) / 10, zoukaY = (lookAt[4] - y) / 10, zoukaZ = (lookAt[5] - z) / 10;

            //Gl.glPushMatrix();
            Glu.gluLookAt(30.0 + x, -7.0 - y, -80.0 + z, x, y, z, 0.0, -1.0, 0.0);
            //Glu.gluLookAt(30.0 + x, -7.0 - y, -80.0 + z, x, y, z, 0.0, -1.0, 0.0);
            //Glu.gluLookAt(30.0 + x, -7.0 - y, -80.0 + z, x, y, z, 0.0, -1.0, 0.0);
            
            lookAt = new double[]{30.0 + x, -7.0 - y, -80.0 + z, x, y, z};
            addLog("視点中心 " + x + "," + y + "," + z);
            view.Invalidate();
        }

        private void box_size_ValueChanged(object sender, EventArgs e)
        {
            if (getCurrentBox() != null && !sousa)
            {
                boxs[boxList.SelectedIndex].width = (int)box_width.Value;
                boxs[boxList.SelectedIndex].height = (int)box_height.Value;
                boxs[boxList.SelectedIndex].depth = (int)box_depth.Value;
                view.Invalidate();
                textureImage.Invalidate();
            }
        }

        private GlBox getCurrentBox()
        {
            if (boxList.SelectedIndex >= 0)
            {
                GlBox box = boxs[boxList.SelectedIndex];
                return box;
            }
            return null;
        }

        private void box_pos_ValueChanged(object sender, EventArgs e)
        {
            if (getCurrentBox() != null && !sousa)
            {
                boxs[boxList.SelectedIndex].x = (double)box_x.Value;
                boxs[boxList.SelectedIndex].y = (double)box_y.Value;
                boxs[boxList.SelectedIndex].z = (double)box_z.Value;
                lookMove(boxs[boxList.SelectedIndex].x, boxs[boxList.SelectedIndex].y, boxs[boxList.SelectedIndex].z);
                view.Invalidate();
            }
        }

        private void box_offset_ValueChanged(object sender, EventArgs e)
        {
            if (getCurrentBox() != null && !sousa)
            {
                boxs[boxList.SelectedIndex].offsetX = (double)box_ox.Value;
                boxs[boxList.SelectedIndex].offsetY = (double)box_oy.Value;
                boxs[boxList.SelectedIndex].offsetZ = (double)box_oz.Value;
                view.Invalidate();
            }
        }

        private void button1_Click(object sender, EventArgs e)
        {
            if (boxList.SelectedIndex != -1)
            {
                if (box_name.ReadOnly)
                {
                    box_name.ReadOnly = false;
                    box_name.Focus();
                    box_name.Select(0, box_name.Text.Length);
                }
                else
                {
                    if (box_name.Text != null && box_name.Text != "" && programString(box_name.Text) && !boxList.Items.Contains(box_name.Text))
                    {
                        boxList.Items[boxList.SelectedIndex] = box_name.Text;
                        boxs[boxList.SelectedIndex].name = box_name.Text;
                        box_name.ReadOnly = true;
                    }
                    else if (boxList.Items[boxList.SelectedIndex].Equals(box_name.Text))
                    {
                        boxList.Items[boxList.SelectedIndex] = box_name.Text;
                        boxs[boxList.SelectedIndex].name = box_name.Text;
                        box_name.ReadOnly = true;
                    }
                    else
                    {
                        addLog("リネーム失敗 " + boxList.Items[boxList.SelectedIndex] + " -> " + box_name.Text);
                        box_name.Focus();
                        box_name.Select(0, box_name.Text.Length);
                    }
                }
            }
        }

        private void box_texture_ValueChanged(object sender, EventArgs e)
        {
            if (getCurrentBox() != null && !sousa)
            {
                boxs[boxList.SelectedIndex].texturePoint.X = (int)box_textureX.Value;
                boxs[boxList.SelectedIndex].texturePoint.Y = (int)box_textureY.Value;
                view.Invalidate();
                textureImage.Invalidate();
            }
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            textureImageSize();
            firstFrom.Hide();
            String[] bases = Directory.GetFiles(appPath + "Data/Extends/", "*.rhn");
            extendsModel.Items.Clear();
            for (int i = 0; i < bases.Length; i++)
            {
                extendsModel.Items.Add(bases[i].Replace(appPath + "Data/Extends/", "").Replace(".rhn", ""));
            }
            String[] dirMacros = Directory.GetFiles(appPath + "Data/Macros/", "*.rb");
            macros.Items.Clear();
            for (int i = 0; i < dirMacros.Length; i++)
            {
                macros.Items.Add(dirMacros[i].Replace(appPath + "Data/Macros/", "").Replace(".rb", ""));
            }
            
            extendsModel.SelectedIndex = extendsModel.Items.IndexOf("ModelBase");
        }

        private void texture_size_SelectedIndexChanged(object sender, EventArgs e)
        {
            textureImageSize();
        }

        private void textureScale_Scroll(object sender, EventArgs e)
        {
            textureImageSize();
        }

        private void textureImageSize()
        {
            int texWidth = int.Parse(texture_width.Text);
            int texHeight = int.Parse(texture_height.Text);
            textureImage.Size = new Size(texWidth * textureScale.Value, texHeight * textureScale.Value);
            int x = (panel3.Width - texWidth * textureScale.Value) / 2;
            int y = (panel3.Height - texHeight * textureScale.Value) / 2;
            x = Math.Max(x, 0);
            y = Math.Max(y, 0);
            textureImage.Location = new Point(x, y);
            textureImage.Invalidate();
        }

        private void textureImage_Paint(object sender, PaintEventArgs e)
        {
            int scale = textureScale.Value;
            e.Graphics.InterpolationMode = System.Drawing.Drawing2D.InterpolationMode.NearestNeighbor;

            ImageAttributes ia = new ImageAttributes();
            ColorMatrix cm = new ColorMatrix();
            cm.Matrix00 = 1;
            cm.Matrix11 = 1;
            cm.Matrix22 = 1;
            cm.Matrix33 = 0.8F;
            if (!boxCheck.Checked)
            {
                cm.Matrix33 = 1F;
            }
            cm.Matrix44 = 1;
            ia.SetColorMatrix(cm);

            if (modelTex != null)
            {
                e.Graphics.PixelOffsetMode = System.Drawing.Drawing2D.PixelOffsetMode.HighQuality;
                e.Graphics.DrawImage(modelTex, new Rectangle(new Point(0, 0), new Size(modelTex.Width * scale, modelTex.Height * scale)), 0, 0, modelTex.Width, modelTex.Height, GraphicsUnit.Pixel, ia);
            }


            if (boxCheck.Checked)
            {
                for (int i = 0; i < boxs.Count; i++)
                {
                    if (boxs[i] != null)
                    {

                        e.Graphics.PixelOffsetMode = System.Drawing.Drawing2D.PixelOffsetMode.HighQuality;
                        e.Graphics.InterpolationMode = System.Drawing.Drawing2D.InterpolationMode.NearestNeighbor;
                        if (boxs[i].getImage() != null)
                        {
                            e.Graphics.DrawImage(boxs[i].getImage(), new Rectangle(boxs[i].texturePoint.X * scale, boxs[i].texturePoint.Y * scale, boxs[i].getImage().Width * scale, boxs[i].getImage().Height * scale), 0, 0, boxs[i].getImage().Width, boxs[i].getImage().Height, GraphicsUnit.Pixel, ia);

                            if (boxList.SelectedIndex == i)
                            {
                                e.Graphics.DrawRectangle(Pens.Gray, new Rectangle(new Point(boxs[i].texturePoint.X * scale + 1, boxs[i].texturePoint.Y * scale + 1), new Size(boxs[i].getImage().Width * scale - 1, boxs[i].getImage().Height * scale - 1)));
                            }
                        }
                    }
                }
            }

            if (gridCheck.Checked && textureScale.Value > 3)
            {
                int texWidth = int.Parse(texture_width.Text);
                int texHeight = int.Parse(texture_height.Text);
                for (int i = 0; i < texWidth; i++)
                {
                    e.Graphics.DrawLine(Pens.LightGray, new Point(i * textureScale.Value, 0), new Point(i * textureScale.Value, texHeight * textureScale.Value));
                }
                for (int i = 0; i < texHeight; i++)
                {
                    e.Graphics.DrawLine(Pens.LightGray, new Point(0, i * textureScale.Value), new Point(texWidth * textureScale.Value, i * textureScale.Value));
                }
            }
        }

        private void tabControl2_SelectedIndexChanged(object sender, EventArgs e)
        {
            groupBox1.Enabled = false;
            groupBox2.Enabled = false;
            groupBox3.Enabled = false;
            groupBox4.Enabled = false;
            groupBox5.Enabled = false;
            box_scale.Enabled = false;
            label9.Enabled = false;
            if (tabControl2.SelectedIndex == 0)
            {
                groupBox1.Enabled = true;
                groupBox2.Enabled = true;
                groupBox3.Enabled = true;
                groupBox4.Enabled = true;
                box_scale.Enabled = true;
                label9.Enabled = true;
                view.Focus();
            }
            else if (tabControl2.SelectedIndex == 1)
            {
                groupBox5.Enabled = true;
                textureImageSize();
            }
        }

        private void textureImage_MouseDown(object sender, MouseEventArgs e)
        {
            if ((e.Button & System.Windows.Forms.MouseButtons.Left) == System.Windows.Forms.MouseButtons.Left)
            {
                if (boxList.SelectedIndex != -1)
                {
                    Point imgP = boxs[boxList.SelectedIndex].texturePoint;
                    imgP.X *= textureScale.Value;
                    imgP.Y *= textureScale.Value;
                    Image img = boxs[boxList.SelectedIndex].getImage();
                    if (e.X < (img.Width * textureScale.Value) + imgP.X && e.X > imgP.X && e.Y < (img.Height * textureScale.Value) + imgP.Y && e.Y > imgP.Y)
                    {
                        hasTexture = true;
                        hasTexturePoint = new Point(e.X / textureScale.Value, e.Y / textureScale.Value);
                        return;
                    }

                    for (int i = boxList.Items.Count - 1; i >= 0; i--)
                    {
                        imgP = boxs[i].texturePoint;
                        imgP.X *= textureScale.Value;
                        imgP.Y *= textureScale.Value;
                        Image uimg = boxs[i].getImage();
                        if (e.X < (uimg.Width * textureScale.Value) + imgP.X && e.X > imgP.X && e.Y < (uimg.Height * textureScale.Value) + imgP.Y && e.Y > imgP.Y)
                        {
                            boxList.SelectedIndex = i;
                            hasTexture = true;
                            hasTexturePoint = new Point(e.X / textureScale.Value, e.Y / textureScale.Value);
                            textureImage.Invalidate();
                            break;
                        }
                    }
                }
            }
        }

        private void textureImage_MouseMove(object sender, MouseEventArgs e)
        {
            int x = (e.X / textureScale.Value - hasTexturePoint.X);
            int y = (e.Y / textureScale.Value - hasTexturePoint.Y);
            if ((e.Button & System.Windows.Forms.MouseButtons.Left) == System.Windows.Forms.MouseButtons.Left && hasTexture)
            {
                boxs[boxList.SelectedIndex].texturePoint.X += x;
                boxs[boxList.SelectedIndex].texturePoint.Y += y;
                sousa = true;
                box_textureX.Value = boxs[boxList.SelectedIndex].texturePoint.X;
                box_textureY.Value = boxs[boxList.SelectedIndex].texturePoint.Y;
                sousa = false;
                hasTexturePoint = new Point(e.X / textureScale.Value, e.Y / textureScale.Value);
                textureImage.Invalidate();
            }
        }

        private void textureImage_MouseUp(object sender, MouseEventArgs e)
        {
            if ((e.Button & System.Windows.Forms.MouseButtons.Left) == System.Windows.Forms.MouseButtons.Left && hasTexture)
            {
                hasTexture = false;
            }
        }

        private void gridCheck_CheckedChanged(object sender, EventArgs e)
        {
            textureImage.Invalidate();
        }

        private void view_KeyUp(object sender, KeyEventArgs e)
        {

            if (e.KeyData == Keys.A)
            {
                currentKey += 1;
                currentKey %= 4;
                labelLoad();
            }
            else if (e.KeyData == Keys.S)
            {
                currentKey += 3;
                currentKey %= 4;
                labelLoad();
            }
        }

        private void keyMove(int par1, int par2)
        {
            if (par2 == -1)
                return;

            try
            {
                if (currentKey == 0)
                {
                    NumericUpDown[] nums = { box_width, box_height, box_depth };
                    nums[par2].Value += par1;
                }
                else if (currentKey == 1)
                {
                    NumericUpDown[] nums = { box_x, box_y, box_z };
                    nums[par2].Value += par1;
                }
                else if (currentKey == 2)
                {
                    NumericUpDown[] nums = { box_ox, box_oy, box_oz };
                    nums[par2].Value += par1;
                }
                else if (currentKey == 3)
                {
                    NumericUpDown[] nums = { box_angleX, box_angleY, box_angleZ };
                    nums[par2].Value += par1;
                }
                view.Invalidate();
            }
            catch (Exception ex)
            {
                addLog(ex.Message);
            }
        }

        private void labelLoad()
        {
            String[] strs = { "大きさ", "位置(回転の中心)", "位置(相対位置)", "角度"};
            shortKeyLabel.Text = "[現]ショートカットキー対象: " + strs[currentKey];
        }

        private void view_KeyDown(object sender, KeyEventArgs e)
        {

            view.Invalidate();
        }

        private void Form1_Resize(object sender, EventArgs e)
        {
            tabControl2.Size = new Size(this.Width - 424, this.Height - 110);
            glPaintEvt();
            textureImageSize();
            addLog("OpenGLリサイズ完了 W:" + this.Width + " H:" + this.Height);
        }

        private void boxList_MouseUp(object sender, MouseEventArgs e)
        {
            if (e.Button == System.Windows.Forms.MouseButtons.Right)
            {
                int index = boxList.IndexFromPoint(e.Location);
                if (index >= 0)
                {
                    boxList.ClearSelected();
                    boxList.SelectedIndex = index;
                }
            }
        }

        private void right_Copy_Click(object sender, EventArgs e)
        {
            if (boxList.SelectedIndex != -1)
            {
                boxClipBoard = boxs[boxList.SelectedIndex];
            }
        }

        private void right_Paste_Click(object sender, EventArgs e)
        {
            if (boxClipBoard != null)
            {
                String name = boxClipBoard.name;
                for (int i = 0; i < 999; i++)
                {
                    name += "Copy";
                    if (!boxList.Items.Contains(name))
                    {
                        break;
                    }
                }
                GlBox _box = new GlBox(boxClipBoard.width, boxClipBoard.height, boxClipBoard.depth, boxClipBoard.x, boxClipBoard.y, boxClipBoard.z, boxClipBoard.offsetX, boxClipBoard.offsetY, boxClipBoard.offsetZ);
                _box.angleX = boxClipBoard.angleX;
                _box.angleY = boxClipBoard.angleY;
                _box.angleZ = boxClipBoard.angleZ;
                _box.name = name;
                boxs.Add(_box);
                boxList.Items.Add(name);
                boxList.SelectedIndex = boxList.Items.Count - 1;
                view.Invalidate();
                textureImage.Invalidate();
                view.Focus();
            }
        }

        private void rightDel_Click(object sender, EventArgs e)
        {
            if (boxList.SelectedIndex != -1)
            {
                int boxId = boxList.SelectedIndex;
                boxs.RemoveAt(boxId);
                boxList.Items.RemoveAt(boxId);
                if (boxList.Items.Count == boxId)
                {
                    boxList.SelectedIndex = boxId - 1;
                }
                else if (boxList.Items.Count != 0)
                {
                    boxList.SelectedIndex = boxId;
                }

                view.Invalidate();
                textureImage.Invalidate();
                view.Focus();
            }
        }

        private void loadImage_Click(object sender, EventArgs e)
        {
            if (openFileDialog1.ShowDialog() == System.Windows.Forms.DialogResult.OK)
            {
                imgTextPath.Text = openFileDialog1.FileName;
                Image p = CreateImage(imgTextPath.Text);
                modelTex = p;
                openFileDialog1.FileName = "";
                textureImage.Invalidate();
            }
        }

        public static Image CreateImage(string filename)
        {
            if (File.Exists(filename))
            {
                System.IO.FileStream fs = new System.IO.FileStream(filename, System.IO.FileMode.Open, System.IO.FileAccess.Read);
                System.Drawing.Image img = System.Drawing.Image.FromStream(fs);
                fs.Close();
                return img;
            }
            return null;
        }

        private void menu_New_Click(object sender, EventArgs e)
        {
            if (boxList.Items.Count != 0)
            {
                if (MessageBox.Show("現在編集されているデータは破棄されます。\r\nよろしいですか?", "Rhenin", MessageBoxButtons.YesNo, MessageBoxIcon.None, MessageBoxDefaultButton.Button2) == System.Windows.Forms.DialogResult.No)
                {
                    return;
                }
            }
            boxList.Items.Clear();
            boxs.Clear();
            texture_width.Text = "" + 64;
            texture_height.Text = "" + 32;
            textureImage.Invalidate();
            view.Invalidate();
        }

        private void menu_Open_Click(object sender, EventArgs e)
        {
            if (openFileDialog2.ShowDialog() == System.Windows.Forms.DialogResult.OK)
            {
                addLog("読み込み" + openFileDialog2.SafeFileName);
                openFile(openFileDialog2.FileName);
                openFileDialog2.FileName = "";
            }
        }

        private void openFile(String filePath)
        {
            String exe = filePath.Split('.')[filePath.Split('.').Length - 1];
            menu_New.PerformClick();
            if (exe.Equals("tcn"))
            {
                Image image;
                List<GlBox> list = ModelLoad.Load(filePath, out image);
                if (list != null)
                {
                    for (int i = 0; i < list.Count; i++)
                    {
                        boxList.Items.Add(list[i].name);
                        boxs.Add(list[i]);
                    }
                    modelTex = image;
                    textureImage.Invalidate();
                    view.Invalidate();
                    editPath = filePath;
                }
                else
                {
                    MessageBox.Show("ファイルが壊れているか、開けません", "Rhenin", MessageBoxButtons.OK, MessageBoxIcon.Error);
                }
                return;
            }
            else if (exe.Equals("rhn"))
            {
                Image image;
                String[] args;
                List<GlBox> list = ModelLoad.LoadRHN(filePath, out image, out args);
                extendsModel.SelectedIndex = extendsModel.Items.IndexOf(args[3]);
                project_package.Text = args[0];
                project_name.Text = args[1];
                project_import.Text = args[2];
                if (list != null)
                {
                    for (int i = 0; i < list.Count; i++)
                    {
                        boxList.Items.Add(list[i].name);
                        boxs.Add(list[i]);
                        boxList.SelectedIndex = 0;
                    }
                    modelTex = image;
                    if (image != null)
                    {
                        texture_width.Text = modelTex.Width.ToString();
                        texture_height.Text = modelTex.Height.ToString();
                    }
                    textureImage.Invalidate();
                    view.Invalidate();
                    editPath = filePath;
                }
                else
                {
                    MessageBox.Show("ファイルが壊れているか、開けません", "Rhenin", MessageBoxButtons.OK, MessageBoxIcon.Error);
                }
                return;
            }
        }

        private void boxCheck_CheckedChanged(object sender, EventArgs e)
        {
            textureImage.Invalidate();
        }

        private void menu_SaveAs_Click(object sender, EventArgs e)
        {
            if (saveFileDialog1.ShowDialog() == System.Windows.Forms.DialogResult.OK)
            {
                exportFile(saveFileDialog1.FileName, 0);
                editPath = saveFileDialog1.FileName;
                saveFileDialog1.FileName = "";
            }
        }

        private void exportFile(String fileName, int id)
        {
            //0 = RHN, 1 = TCN, 2 = CODE, 3 = PNG
            String[] e = fileName.Split('.');
            if (e[e.Length - 1].Equals("rhn")) id = 0;
            if (e[e.Length - 1].Equals("tcn")) id = 1;
            if (id == 0)
            {
                ModelSave.saveRhn(fileName, boxs, boxList, new Size(int.Parse(texture_width.Text), int.Parse(texture_height.Text)), extendsModel.Text, modelTex, new String[]{project_package.Text, project_name.Text, project_import.Text});

            }
            else if (id == 1)
            {
                MessageBox.Show("無料版ではTCN形式での保存は利用できません\r\nライセンスをご購入ください", "Rhenin", MessageBoxButtons.OK, MessageBoxIcon.Error);
            }
        }

        private void menu_Exit_Click(object sender, EventArgs e)
        {
            if (MessageBox.Show("現在編集されているデータは破棄されます。\r\nよろしいですか?", "Rhenin", MessageBoxButtons.YesNo, MessageBoxIcon.None, MessageBoxDefaultButton.Button2) == System.Windows.Forms.DialogResult.No)
            {
                return;
            }
            Application.Exit();
        }

        private void toolStrip_Show_Click(object sender, EventArgs e)
        {
            for (int i = 0; i < boxs.Count; i++)
            {
                boxs[i].drawMode = 0;
            }
            addLog("表示モード 通常");
            drawMode = 0;
            view.Invalidate();
        }

        private void toolStrip_Wire_Click(object sender, EventArgs e)
        {
            for (int i = 0; i < boxs.Count; i++)
            {
                boxs[i].drawMode = 1;
            }
            addLog("表示モード ワイヤー");
            drawMode = 1;
            view.Invalidate();
        }

        private void toolstrip_Hide_Click(object sender, EventArgs e)
        {
            for (int i = 0; i < boxs.Count; i++)
            {
                boxs[i].drawMode = 2;
            }
            addLog("表示モード 非表示");
            drawMode = 2;
            view.Invalidate();
        }

        private void timer1_Tick(object sender, EventArgs e)
        {
            if (System.Windows.Input.Keyboard.IsKeyDown(System.Windows.Input.Key.Up) && System.Windows.Input.Keyboard.IsKeyDown(System.Windows.Input.Key.Z)) keyMove(1, 0);
            if (System.Windows.Input.Keyboard.IsKeyDown(System.Windows.Input.Key.Up) && System.Windows.Input.Keyboard.IsKeyDown(System.Windows.Input.Key.X)) keyMove(1, 1);
            if (System.Windows.Input.Keyboard.IsKeyDown(System.Windows.Input.Key.Up) && System.Windows.Input.Keyboard.IsKeyDown(System.Windows.Input.Key.C)) keyMove(1, 2);
            if (System.Windows.Input.Keyboard.IsKeyDown(System.Windows.Input.Key.Down) && System.Windows.Input.Keyboard.IsKeyDown(System.Windows.Input.Key.Z)) keyMove(-1, 0);
            if (System.Windows.Input.Keyboard.IsKeyDown(System.Windows.Input.Key.Down) && System.Windows.Input.Keyboard.IsKeyDown(System.Windows.Input.Key.X)) keyMove(-1, 1);
            if (System.Windows.Input.Keyboard.IsKeyDown(System.Windows.Input.Key.Down) && System.Windows.Input.Keyboard.IsKeyDown(System.Windows.Input.Key.C)) keyMove(-1, 2);
        }

        private void exportTexture_Click(object sender, EventArgs e)
        {
            if (imageSaveDialog.ShowDialog() == System.Windows.Forms.DialogResult.OK)
            {
                Bitmap bmp = new Bitmap(int.Parse(texture_width.Text), int.Parse(texture_height.Text));
                bmp.MakeTransparent();
                Graphics g = Graphics.FromImage(bmp);
                for (int i = 0; i < boxs.Count; i++)
                {
                    g.DrawImage(boxs[i].getImage(), boxs[i].texturePoint);
                }
                bmp.Save(imageSaveDialog.FileName, ImageFormat.Png);
                g.Dispose();
                imageSaveDialog.FileName = "";
                bmp.Dispose();
            }
        }

        private void tools_New_Click(object sender, EventArgs e)
        {
            menu_New.PerformClick();
        }

        private void tools_Open_Click(object sender, EventArgs e)
        {
            menu_Open.PerformClick();
        }

        private void tools_Save_Click(object sender, EventArgs e)
        {
            menu_Save.PerformClick();
        }

        private void menu_Save_Click(object sender, EventArgs e)
        {
            if (File.Exists(editPath))
            {
                if (editPath == null)
                {
                    menu_SaveAs.PerformClick();
                }
                else
                {
                    exportFile(editPath, 0);
                }
            }
            else
            {
                menu_SaveAs.PerformClick();
            }
        }

        private void texture_reload_Click(object sender, EventArgs e)
        {
            modelTex = CreateImage(imgTextPath.Text);
            view.Invalidate();
            textureImage.Invalidate();
        }

        private void saveImage_Click(object sender, EventArgs e)
        {
            if (modelTex == null)
            {
                return;
            }
            if (imageSaveDialog.ShowDialog() == System.Windows.Forms.DialogResult.OK)
            {
                Bitmap bmp = (Bitmap)modelTex;
                bmp.Save(imageSaveDialog.FileName, ImageFormat.Png);
                imageSaveDialog.FileName = "";
            }
        }

        private void exportJava_Click(object sender, EventArgs e)
        {
            SaveFileDialog sfd = new SaveFileDialog();
            sfd.FileName = "";
            sfd.Filter = "Javaファイル(*.java)|*.java";
            if (sfd.ShowDialog() == System.Windows.Forms.DialogResult.OK)
            {
                addLog("Java 出力");
                StreamReader fs = new StreamReader(appPath + "Data/Export/exportJava.java");
                String code = fs.ReadToEnd();
                fs.Close();
                code = code.Replace("%pack%", project_package.Text);
                code = code.Replace("%classname%", project_name.Text);
                code = code.Replace("%extend%", extendsModel.Text);
                code = code.Replace("%width%", texture_width.Text);
                code = code.Replace("%height%", texture_height.Text);
                code = code.Replace("%fields%", makeFields());
                code = code.Replace("%import%", makeImports());
                code = code.Replace("%init%", makeInits());
                code = code.Replace("%renders%", makeRenders());
                StreamWriter sw = new StreamWriter(sfd.FileName);
                sw.Write(code);
                sw.Close();
            }
        }

        private String makeFields()
        {
            String result = "";
            for (int i = 0; i < boxs.Count; i++)
            {
                result += "\tModelRenderer " + boxs[i].name + ";\r\n";
            }
            return result;
        }

        private String makeImports()
        {
            String result = "";
            for (int i = 0; i < project_import.Lines.Length; i++)
            {
                result += "import " + project_import.Lines[i] + ";\r\n";
            }
            return result;
        }

        private String makeRenders()
        {
            String result = "";
            for (int i = 0; i < boxs.Count; i++)
            {
                result += "\t\t" + boxs[i].name + ".render(par7);\r\n";
            }
            return result;
        }

        private String makeInits()
        {
            String result = "";
            for (int i = 0; i < boxs.Count; i++)
            {
                result += "\t\t" + boxs[i].name + " = new ModelRenderer(this, " + boxs[i].texturePoint.X + ", " + boxs[i].texturePoint.Y + ");\r\n";
                result += "\t\t" + boxs[i].name + ".addBox(" + boxs[i].offsetX + "F, " + boxs[i].offsetY + "F, " + boxs[i].offsetZ + "F, " + ((int)boxs[i].width) + "," + ((int)boxs[i].height) + "," + ((int)boxs[i].depth) + ");\r\n";
                result += "\t\t" + boxs[i].name + ".setRotationPoint(" + boxs[i].x + "F, " + boxs[i].y + "F, " + boxs[i].z + "F);\r\n";
                result += "\t\tsetRotation(" + boxs[i].name + ", " + ((float)boxs[i].angleX) + "F, " + ((float)boxs[i].angleY) + "F, " + ((float)boxs[i].angleZ) + "F);\r\n";
                result += "\t\t" + boxs[i].name + ".setTextureSize(" + texture_width.Text + ", " + texture_height.Text + ");\r\n\r\n";
            }
            return result;
        }

        private void menu_Copy_Click(object sender, EventArgs e)
        {
            right_Copy.PerformClick();
        }

        private void menu_Paste_Click(object sender, EventArgs e)
        {
            right_Paste.PerformClick();
        }

        private void menu_del_Click(object sender, EventArgs e)
        {
            rightDel.PerformClick();
        }

        private void menu_boxNew_Click(object sender, EventArgs e)
        {
            addBox.PerformClick();
        }

        private void menu_Donate_Click(object sender, EventArgs e)
        {
            MessageBox.Show("あなたは、100円寄付しました");
            MessageBox.Show("ガチで寄付してくれる方がおりましたら、\r\nTwitter[@notosanz]までご連絡ください");
        }

        private void Form1_FormClosing(object sender, FormClosingEventArgs e)
        {
            if (boxList.Items.Count > 0)
            {
                if (MessageBox.Show("現在編集されているデータは破棄されます。\r\nよろしいですか?", "Rhenin", MessageBoxButtons.YesNo, MessageBoxIcon.None, MessageBoxDefaultButton.Button2) == System.Windows.Forms.DialogResult.No)
                {
                    e.Cancel = true;
                    return;
                }
            }
            
        }

        private void menu_Version_Click(object sender, EventArgs e)
        {
            MessageBox.Show("Rhenin " + version + "\r\n作者:バーニングファイティングファイターのなりかけ(C)\r\n  再配布はお断りします", "Rhenin");
        }

        private void menu_koukoku_Click(object sender, EventArgs e)
        {
            System.Diagnostics.Process.Start("http://www.amazon.co.jp/%E4%BF%BA%E3%81%AE%E5%BD%BC%E5%A5%B3%E3%81%A8%E5%B9%BC%E3%81%AA%E3%81%98%E3%81%BF%E3%81%8C%E4%BF%AE%E7%BE%85%E5%A0%B4%E3%81%99%E3%81%8E%E3%82%8B-GA%E6%96%87%E5%BA%AB-%E8%A3%95%E6%99%82-%E6%82%A0%E7%A4%BA/dp/4797363967");
        }

        private void zoom_e_Click(object sender, EventArgs e)
        {
            scale = Math.Min(5.0D, scale + 0.05D);
            view.Invalidate();
        }

        private void zoom_s_Click(object sender, EventArgs e)
        {
            scale = Math.Max(0.05D, scale - 0.05D);
            view.Invalidate();
        }

        private void zoom_r_Click(object sender, EventArgs e)
        {
            scale = 1.0D;
            view.Invalidate();
        }

        private void tools_Copy_Click(object sender, EventArgs e)
        {
            menu_Copy.PerformClick();
        }

        private void tools_Paste_Click(object sender, EventArgs e)
        {
            menu_Paste.PerformClick();
        }

        private void extendsModel_SelectedIndexChanged(object sender, EventArgs e)
        {
            Image img;
            String[] args;
            baseModel = ModelLoad.LoadRHN(appPath + "Data/Extends/" + extendsModel.Text + ".rhn", out img, out args);
        }

        private void box_scale_ValueChanged(object sender, EventArgs e)
        {
            if (getCurrentBox() != null && !sousa)
            {
                boxs[boxList.SelectedIndex].scale = (double)box_scale.Value;
                view.Invalidate();
            }
        }

        private void baseModel_normal_Click(object sender, EventArgs e)
        {
            baseModelMode = 0;
            view.Invalidate();
        }

        private void baseModel_wire_Click(object sender, EventArgs e)
        {
            baseModelMode = 1;
            view.Invalidate();
        }

        private void baseModel_hide_Click(object sender, EventArgs e)
        {
            baseModelMode = 2;
            view.Invalidate();
        }

        private void backUp_Timer_Tick(object sender, EventArgs e)
        {
            addLog("バックアップ " + DateTime.Now);
            exportFile(appPath + "Data/BackUp/" + DateTime.Now.ToString("yyyy_MM_dd_HH_mm_ss") + ".rhn", 0);
        }

        private void Form1_DragEnter(object sender, DragEventArgs e)
        {
            if (e.Data.GetDataPresent(DataFormats.FileDrop))
            {
                e.Effect = DragDropEffects.Copy;
            }
            else
            {
                e.Effect = DragDropEffects.None;
            }
        }

        private void Form1_DragDrop(object sender, DragEventArgs e)
        {
            string[] fileNames = (string[])e.Data.GetData(DataFormats.FileDrop, false);
            if (fileNames != null & fileNames[0] != null)
            {
                openFile(fileNames[0]);
                addLog("ドラッグ読み込み " + fileNames[0]);
            }

            textureImage.Invalidate();
            view.Invalidate();
        }

        private void macros_SelectedIndexChanged(object sender, EventArgs e)
        {
            if (macros.SelectedIndex != -1)
            {
                macro_run.Enabled = true;
            }
        }

        private void macro_run_Click(object sender, EventArgs e)
        {
            Runnable.run(appPath + "Data/Macros/" + macros.Text + ".rb", macro_args.Text);
        }

        private void keyDown_Tick(object sender, EventArgs e)
        {
            if (System.Windows.Input.Keyboard.IsKeyDown(System.Windows.Input.Key.Up) && System.Windows.Input.Keyboard.IsKeyDown(System.Windows.Input.Key.Z)) keyMove(1, 0);
            if (System.Windows.Input.Keyboard.IsKeyDown(System.Windows.Input.Key.Up) && System.Windows.Input.Keyboard.IsKeyDown(System.Windows.Input.Key.X)) keyMove(1, 1);
            if (System.Windows.Input.Keyboard.IsKeyDown(System.Windows.Input.Key.Up) && System.Windows.Input.Keyboard.IsKeyDown(System.Windows.Input.Key.C)) keyMove(1, 2);

            if (System.Windows.Input.Keyboard.IsKeyDown(System.Windows.Input.Key.Down) && System.Windows.Input.Keyboard.IsKeyDown(System.Windows.Input.Key.Z)) keyMove(-1, 0);
            if (System.Windows.Input.Keyboard.IsKeyDown(System.Windows.Input.Key.Down) && System.Windows.Input.Keyboard.IsKeyDown(System.Windows.Input.Key.X)) keyMove(-1, 1);
            if (System.Windows.Input.Keyboard.IsKeyDown(System.Windows.Input.Key.Down) && System.Windows.Input.Keyboard.IsKeyDown(System.Windows.Input.Key.C)) keyMove(-1, 2);

            if (System.Windows.Input.Keyboard.IsKeyDown(System.Windows.Input.Key.Up) && System.Windows.Input.Keyboard.IsKeyDown(System.Windows.Input.Key.LeftCtrl) && boxList.SelectedIndex != -1 && keyCount <= 0)
            {
                int select = (boxList.SelectedIndex + (boxList.Items.Count - 1)) % boxList.Items.Count;
                boxList.SelectedIndex = select;
                keyCount = 10;
            }
            else if (System.Windows.Input.Keyboard.IsKeyDown(System.Windows.Input.Key.Down) && System.Windows.Input.Keyboard.IsKeyDown(System.Windows.Input.Key.LeftCtrl) && boxList.SelectedIndex != -1 && keyCount <= 0)
            {
                int select = (boxList.SelectedIndex + 1) % boxList.Items.Count;
                boxList.SelectedIndex = select;
                keyCount = 10;
            }
            else
            {
                keyCount = 0;
            }
            keyCount--;
        }

        private void menu_shortKutList_Click(object sender, EventArgs e)
        {
            if (!showHelp)
            {
                ShortCutList f = new ShortCutList();
                f.Owner = this;
                f.Show();
                showHelp = true;    
            }
        }
    }
}
