﻿using System;
using System.ComponentModel;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using IronRuby.Runtime;
using IronRuby;
using System.IO;
using System.Threading;

namespace Rhenin
{
    public class Runnable
    {
        public static void run(String path, String args)
        {
            BackgroundWorker bw = new BackgroundWorker();
            bw.DoWork += bw_DoWork;
            bw.RunWorkerAsync(new Object[]{path, args.Split(',')});
            
        }

        static void bw_DoWork(object sender, DoWorkEventArgs e)
        {
            StreamReader sr = new StreamReader((String)((Object[])e.Argument)[0], Encoding.GetEncoding("shift_jis"));
            String mainSrc = sr.ReadToEnd();
            sr.Close();
            var engine = Ruby.CreateEngine();
            var src = engine.CreateScriptSourceFromString(mainSrc);
            var scp = engine.CreateScope();
            scp.SetVariable("args", ((String[])((Object[])e.Argument)[1]));
            scp.SetVariable("rhenin", new App());
            src.Execute(scp);
        }
    }

    public class App
    {
        public void Log(String par1)
        {
            Form1.instance.addLog(par1);
        }

        public int GetSelectedIndex()
        {
            return Form1.instance.boxList.SelectedIndex;
        }

        public int GetBoxsCount()
        {
            return Form1.instance.boxs.Count;
        }

        public int GetBoxWidth(int i)
        {
            List<GlBox> boxs = Form1.instance.boxs;
            return (int)boxs[i].width;
        }

        public int GetBoxHeight(int i)
        {
            List<GlBox> boxs = Form1.instance.boxs;
            return (int)boxs[i].height;
        }

        public int GetBoxDepth(int i)
        {
            List<GlBox> boxs = Form1.instance.boxs;
            return (int)boxs[i].depth;
        }

        public double GetBoxX(int i)
        {
            return Form1.instance.boxs[i].x;
        }

        public double GetBoxY(int i)
        {
            return Form1.instance.boxs[i].y;
        }

        public double GetBoxZ(int i)
        {
            return Form1.instance.boxs[i].z;
        }

        public double GetBoxOffsetX(int i)
        {
            return Form1.instance.boxs[i].offsetX;
        }

        public double GetBoxOffsetY(int i)
        {
            return Form1.instance.boxs[i].offsetY;
        }

        public double GetBoxOffsetZ(int i)
        {
            return Form1.instance.boxs[i].offsetZ;
        }

        public double GetBoxAngleX(int i)
        {
            return Form1.instance.boxs[i].angleX;
        }

        public double GetBoxAngleY(int i)
        {
            return Form1.instance.boxs[i].angleY;
        }

        public double GetBoxAngleZ(int i)
        {
            return Form1.instance.boxs[i].angleZ;
        }

        public int GetBoxTextureX(int i)
        {
            return Form1.instance.boxs[i].texturePoint.X;
        }

        public int GetBoxTextureY(int i)
        {
            return Form1.instance.boxs[i].texturePoint.Y;
        }

        public void SetBoxWidth(int i, int j)
        {
            Form1.instance.boxs[i].width = j;
        }

        public void SetBoxHeight(int i, int j)
        {
            Form1.instance.boxs[i].height = j;
        }

        public void SetBoxDepth(int i, int j)
        {
            Form1.instance.boxs[i].depth = j;
        }

        public void SetBoxX(int i, double j)
        {
            Form1.instance.boxs[i].x = j;
        }

        public void SetBoxY(int i, double j)
        {
            Form1.instance.boxs[i].y = j;
        }

        public void SetBoxZ(int i, double j)
        {
            Form1.instance.boxs[i].z = j;
        }

        public void SetBoxOffsetX(int i, double j)
        {
            Form1.instance.boxs[i].offsetX = j;
        }

        public void SetBoxOffsetY(int i, double j)
        {
            Form1.instance.boxs[i].offsetY = j;
        }

        public void SetBoxOffsetZ(int i, double j)
        {
            Form1.instance.boxs[i].offsetZ = j;
        }

        public void SetBoxAngleX(int i, double j)
        {
            Form1.instance.boxs[i].angleX = j;
        }

        public void SetBoxAngleY(int i, double j)
        {
            Form1.instance.boxs[i].angleY = j;
        }

        public void SetBoxAngleZ(int i, double j)
        {
            Form1.instance.boxs[i].angleZ = j;
        }

        public void SetBoxTextureX(int i, int j)
        {
            Form1.instance.boxs[i].texturePoint.X = j;
        }

        public void SetBoxTextureY(int i, int j)
        {
            Form1.instance.boxs[i].texturePoint.Y = j;
        }

        public String GetVersion()
        {
            return Form1.version;
        }
    }
}
